/* Machine-generated using Migen */
module ft601_hsfpx002(
	inout [31:0] usb_fifo_data,
	inout [3:0] usb_fifo_be,
	input usb_fifo_txe_n,
	input usb_fifo_rxf_n,
	output usb_fifo_wr_n,
	output usb_fifo_rd_n,
	output usb_fifo_oe_n,
	output usb_fifo_wakeup_n,
	input clk100
);

wire sys_clk;
wire sys_rst;
wire por_clk;
reg int_rst = 1'd1;
wire incoming_fifo_syncfifo_we;
wire incoming_fifo_syncfifo_writable;
wire incoming_fifo_syncfifo_re;
wire incoming_fifo_syncfifo_readable;
wire [31:0] incoming_fifo_syncfifo_din;
wire [31:0] incoming_fifo_syncfifo_dout;
reg [11:0] incoming_fifo_level = 12'd0;
reg incoming_fifo_replace = 1'd0;
reg [10:0] incoming_fifo_produce = 11'd0;
reg [10:0] incoming_fifo_consume = 11'd0;
reg [10:0] incoming_fifo_wrport_adr;
wire [31:0] incoming_fifo_wrport_dat_r;
wire incoming_fifo_wrport_we;
wire [31:0] incoming_fifo_wrport_dat_w;
wire incoming_fifo_do_read;
wire [10:0] incoming_fifo_rdport_adr;
wire [31:0] incoming_fifo_rdport_dat_r;
wire outgoing_fifo_syncfifo_we;
wire outgoing_fifo_syncfifo_writable;
wire outgoing_fifo_syncfifo_re;
wire outgoing_fifo_syncfifo_readable;
wire [31:0] outgoing_fifo_syncfifo_din;
wire [31:0] outgoing_fifo_syncfifo_dout;
reg [11:0] outgoing_fifo_level = 12'd0;
reg outgoing_fifo_replace = 1'd0;
reg [10:0] outgoing_fifo_produce = 11'd0;
reg [10:0] outgoing_fifo_consume = 11'd0;
reg [10:0] outgoing_fifo_wrport_adr;
wire [31:0] outgoing_fifo_wrport_dat_r;
wire outgoing_fifo_wrport_we;
wire [31:0] outgoing_fifo_wrport_dat_w;
wire outgoing_fifo_do_read;
wire [10:0] outgoing_fifo_rdport_adr;
wire [31:0] outgoing_fifo_rdport_dat_r;
wire [31:0] data_tri_o;
wire data_tri_oe;
wire [31:0] data_tri_i;
wire [3:0] be_tri_o;
wire be_tri_oe;
wire [3:0] be_tri_i;
wire rxf_n;
wire txe_n;
wire wr_n;
wire rd_n;
wire oe_n;
reg curr_op = 1'd1;
wire can_read;
wire can_write;
reg is_ongoing0;
reg is_ongoing1;
reg is_ongoing2;
reg is_ongoing3;
reg is_ongoing4;
reg is_ongoing5;
reg is_ongoing6;
reg [1:0] state = 2'd0;
reg [1:0] next_state;
reg curr_op_next_value;
reg curr_op_next_value_ce;

// synthesis translate_off
reg dummy_s;
initial dummy_s <= 1'd0;
// synthesis translate_on

assign outgoing_fifo_syncfifo_din = incoming_fifo_syncfifo_dout;
assign outgoing_fifo_syncfifo_we = (incoming_fifo_syncfifo_readable & outgoing_fifo_syncfifo_writable);
assign incoming_fifo_syncfifo_re = (incoming_fifo_syncfifo_readable & outgoing_fifo_syncfifo_writable);
assign sys_clk = clk100;
assign por_clk = clk100;
assign sys_rst = int_rst;
assign usb_fifo_wakeup_n = 1'd0;
assign rxf_n = usb_fifo_rxf_n;
assign txe_n = usb_fifo_txe_n;
assign usb_fifo_rd_n = rd_n;
assign usb_fifo_wr_n = wr_n;
assign usb_fifo_oe_n = oe_n;
assign can_read = ((~rxf_n) & incoming_fifo_syncfifo_writable);
assign can_write = ((~txe_n) & outgoing_fifo_syncfifo_readable);
assign oe_n = (~((incoming_fifo_syncfifo_writable & (~rxf_n)) & (is_ongoing0 | is_ongoing1)));
assign rd_n = (~((incoming_fifo_syncfifo_writable & (~rxf_n)) & is_ongoing2));
assign wr_n = (~((outgoing_fifo_syncfifo_readable & (~txe_n)) & is_ongoing3));
assign data_tri_oe = ((outgoing_fifo_syncfifo_readable & (~txe_n)) & is_ongoing4);
assign incoming_fifo_syncfifo_we = ((incoming_fifo_syncfifo_writable & (~rxf_n)) & is_ongoing5);
assign outgoing_fifo_syncfifo_re = ((outgoing_fifo_syncfifo_readable & (~txe_n)) & is_ongoing6);
assign incoming_fifo_syncfifo_din = data_tri_i;
assign data_tri_o = outgoing_fifo_syncfifo_dout;
assign be_tri_o = 4'd15;
assign be_tri_oe = data_tri_oe;

// synthesis translate_off
reg dummy_d;
// synthesis translate_on
always @(*) begin
	incoming_fifo_wrport_adr <= 11'd0;
	if (incoming_fifo_replace) begin
		incoming_fifo_wrport_adr <= (incoming_fifo_produce - 1'd1);
	end else begin
		incoming_fifo_wrport_adr <= incoming_fifo_produce;
	end
// synthesis translate_off
	dummy_d <= dummy_s;
// synthesis translate_on
end
assign incoming_fifo_wrport_dat_w = incoming_fifo_syncfifo_din;
assign incoming_fifo_wrport_we = (incoming_fifo_syncfifo_we & (incoming_fifo_syncfifo_writable | incoming_fifo_replace));
assign incoming_fifo_do_read = (incoming_fifo_syncfifo_readable & incoming_fifo_syncfifo_re);
assign incoming_fifo_rdport_adr = incoming_fifo_consume;
assign incoming_fifo_syncfifo_dout = incoming_fifo_rdport_dat_r;
assign incoming_fifo_syncfifo_writable = (incoming_fifo_level != 12'd2048);
assign incoming_fifo_syncfifo_readable = (incoming_fifo_level != 1'd0);

// synthesis translate_off
reg dummy_d_1;
// synthesis translate_on
always @(*) begin
	outgoing_fifo_wrport_adr <= 11'd0;
	if (outgoing_fifo_replace) begin
		outgoing_fifo_wrport_adr <= (outgoing_fifo_produce - 1'd1);
	end else begin
		outgoing_fifo_wrport_adr <= outgoing_fifo_produce;
	end
// synthesis translate_off
	dummy_d_1 <= dummy_s;
// synthesis translate_on
end
assign outgoing_fifo_wrport_dat_w = outgoing_fifo_syncfifo_din;
assign outgoing_fifo_wrport_we = (outgoing_fifo_syncfifo_we & (outgoing_fifo_syncfifo_writable | outgoing_fifo_replace));
assign outgoing_fifo_do_read = (outgoing_fifo_syncfifo_readable & outgoing_fifo_syncfifo_re);
assign outgoing_fifo_rdport_adr = outgoing_fifo_consume;
assign outgoing_fifo_syncfifo_dout = outgoing_fifo_rdport_dat_r;
assign outgoing_fifo_syncfifo_writable = (outgoing_fifo_level != 12'd2048);
assign outgoing_fifo_syncfifo_readable = (outgoing_fifo_level != 1'd0);

// synthesis translate_off
reg dummy_d_2;
// synthesis translate_on
always @(*) begin
	is_ongoing0 <= 1'd0;
	is_ongoing1 <= 1'd0;
	is_ongoing2 <= 1'd0;
	is_ongoing3 <= 1'd0;
	is_ongoing4 <= 1'd0;
	is_ongoing5 <= 1'd0;
	is_ongoing6 <= 1'd0;
	next_state <= 2'd0;
	curr_op_next_value <= 1'd0;
	curr_op_next_value_ce <= 1'd0;
	next_state <= state;
	case (state)
		1'd1: begin
			next_state <= 2'd2;
			is_ongoing0 <= 1'd1;
		end
		2'd2: begin
			if ((incoming_fifo_syncfifo_writable & (~rxf_n))) begin
				next_state <= 2'd2;
			end else begin
				next_state <= 1'd0;
			end
			is_ongoing1 <= 1'd1;
			is_ongoing2 <= 1'd1;
			is_ongoing5 <= 1'd1;
		end
		2'd3: begin
			if ((outgoing_fifo_syncfifo_readable & (~txe_n))) begin
				next_state <= 2'd3;
			end else begin
				next_state <= 1'd0;
			end
			is_ongoing3 <= 1'd1;
			is_ongoing4 <= 1'd1;
			is_ongoing6 <= 1'd1;
		end
		default: begin
			if ((((can_read & can_write) & (curr_op == 1'd1)) | (can_read & (~can_write)))) begin
				next_state <= 1'd1;
				curr_op_next_value <= 1'd0;
				curr_op_next_value_ce <= 1'd1;
			end else begin
				if ((((can_read & can_write) & (curr_op == 1'd0)) | ((~can_read) & can_write))) begin
					next_state <= 2'd3;
					curr_op_next_value <= 1'd1;
					curr_op_next_value_ce <= 1'd1;
				end else begin
					next_state <= 1'd0;
				end
			end
		end
	endcase
// synthesis translate_off
	dummy_d_2 <= dummy_s;
// synthesis translate_on
end

always @(posedge por_clk) begin
	int_rst <= 1'd0;
end

always @(posedge sys_clk) begin
	if (((incoming_fifo_syncfifo_we & incoming_fifo_syncfifo_writable) & (~incoming_fifo_replace))) begin
		incoming_fifo_produce <= (incoming_fifo_produce + 1'd1);
	end
	if (incoming_fifo_do_read) begin
		incoming_fifo_consume <= (incoming_fifo_consume + 1'd1);
	end
	if (((incoming_fifo_syncfifo_we & incoming_fifo_syncfifo_writable) & (~incoming_fifo_replace))) begin
		if ((~incoming_fifo_do_read)) begin
			incoming_fifo_level <= (incoming_fifo_level + 1'd1);
		end
	end else begin
		if (incoming_fifo_do_read) begin
			incoming_fifo_level <= (incoming_fifo_level - 1'd1);
		end
	end
	if (((outgoing_fifo_syncfifo_we & outgoing_fifo_syncfifo_writable) & (~outgoing_fifo_replace))) begin
		outgoing_fifo_produce <= (outgoing_fifo_produce + 1'd1);
	end
	if (outgoing_fifo_do_read) begin
		outgoing_fifo_consume <= (outgoing_fifo_consume + 1'd1);
	end
	if (((outgoing_fifo_syncfifo_we & outgoing_fifo_syncfifo_writable) & (~outgoing_fifo_replace))) begin
		if ((~outgoing_fifo_do_read)) begin
			outgoing_fifo_level <= (outgoing_fifo_level + 1'd1);
		end
	end else begin
		if (outgoing_fifo_do_read) begin
			outgoing_fifo_level <= (outgoing_fifo_level - 1'd1);
		end
	end
	state <= next_state;
	if (curr_op_next_value_ce) begin
		curr_op <= curr_op_next_value;
	end
	if (sys_rst) begin
		incoming_fifo_level <= 12'd0;
		incoming_fifo_produce <= 11'd0;
		incoming_fifo_consume <= 11'd0;
		outgoing_fifo_level <= 12'd0;
		outgoing_fifo_produce <= 11'd0;
		outgoing_fifo_consume <= 11'd0;
		curr_op <= 1'd1;
		state <= 2'd0;
	end
end

reg [31:0] storage[0:2047];
reg [31:0] memdat;
always @(posedge sys_clk) begin
	if (incoming_fifo_wrport_we)
		storage[incoming_fifo_wrport_adr] <= incoming_fifo_wrport_dat_w;
	memdat <= storage[incoming_fifo_wrport_adr];
end

always @(posedge sys_clk) begin
end

assign incoming_fifo_wrport_dat_r = memdat;
assign incoming_fifo_rdport_dat_r = storage[incoming_fifo_rdport_adr];

reg [31:0] storage_1[0:2047];
reg [31:0] memdat_1;
always @(posedge sys_clk) begin
	if (outgoing_fifo_wrport_we)
		storage_1[outgoing_fifo_wrport_adr] <= outgoing_fifo_wrport_dat_w;
	memdat_1 <= storage_1[outgoing_fifo_wrport_adr];
end

always @(posedge sys_clk) begin
end

assign outgoing_fifo_wrport_dat_r = memdat_1;
assign outgoing_fifo_rdport_dat_r = storage_1[outgoing_fifo_rdport_adr];

assign usb_fifo_data = data_tri_oe ? data_tri_o : 32'bz;
assign data_tri_i = usb_fifo_data;

assign usb_fifo_be = be_tri_oe ? be_tri_o : 4'bz;
assign be_tri_i = usb_fifo_be;

endmodule
